VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CtConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'local variable(s) to hold property value(s)
Private mvarConnectionType As Long
Private mvarPort As Long
Private mvarBaudRate As Long
Private mvarHostNode As Long
Private mvarTargetNode As Long
Private mvarTargetAddress As Long
Private mvarIPAddress As String
Private mvarTimeout As Long
Private mvarConnectionID As Long
'local variable(s) for upload / download
Private iDevices As Integer, iParameters As Integer
Private iMessages As Integer, iMappings As Integer
Private iExplicits As Integer, flag As Boolean

Private Sub Class_Initialize()
    'set defaults
    mvarConnectionType = SERIAL
    mvarPort = 1
    mvarBaudRate = 19200
    mvarHostNode = 32000
    mvarTargetNode = 0
    mvarConnectionID = 0
    mvarTargetAddress = 0
    mvarIPAddress = ""
    mvarTimeout = 250
End Sub
Private Sub Class_Terminate()
    'close any open connection
    If mvarConnectionID <> 0 Then
        If Not Disconnect Then
            MsgBox "Failed to close connection.", vbExclamation
        End If
    End If

End Sub

Public Property Let Timeout(ByVal vData As Long)
    
    'set value
    mvarTimeout = vData
    
End Property

Public Property Get Timeout() As Long
    
    'get value
    Timeout = mvarTimeout
    
End Property

Public Sub SetTimeout()

    'set timeout
    If CtSetConnectionTimeout(mvarConnectionID, mvarTimeout) <> 1 Then
        MsgBox "Failed to set timeout.", vbExclamation
    End If

End Sub

Public Function Connect() As Boolean
    
    'open connection
    If mvarConnectionID = 0 Then
        mvarConnectionID = CtOpenConnection(mvarConnectionType, mvarPort, mvarTargetAddress)
    End If
    If mvarConnectionID <> 0 Then
        'set baud if serial connection
        If mvarConnectionType = SERIAL Then
            If CtInitConnection(mvarConnectionID, mvarBaudRate, _
                    NO_PARITY, EIGHT_DATA_BITS, ONE_STOP_BITS) <> SUCCESS Then
                MsgBox "Failed to set BAUD rate.", vbExclamation
            End If
        End If
        'set timeout
        If CtSetConnectionTimeout(mvarConnectionID, mvarTimeout) <> SUCCESS Then
            MsgBox "Failed to set timeout.", vbExclamation
        End If
        Connect = True
    Else
        Connect = False
    End If
    
End Function

Public Function Disconnect() As Boolean

    'close connection
    If mvarConnectionID <> 0 Then
        If CtCloseConnection(mvarConnectionID) = 1 Then
            mvarConnectionID = 0
            Disconnect = True
        Else
            Disconnect = False
        End If
    Else
        Disconnect = True
    End If
    
End Function

Public Function GetSetConfiguration(sMsg As String) As String
'pass response up to calling function
On Error GoTo ErrHandler
Dim sRsp As String * 512
Dim ErrData As CT_ERR_INFO

    'send message
    If CtSendData(mvarConnectionID, 20, sMsg, Len(sMsg), sRsp) = SUCCESS Then
        messlen = Asc(Mid(sRsp, 1, 1))
        GetSetConfiguration = Mid(sRsp, 1, 1 + messlen)
        Exit Function
    Else
        If CtGetErrorInfo(mvarConnectionID, ErrData) = SUCCESS Then
            MsgBox "Error: " & ErrData.lCode & " " & ErrData.sMessage, vbExclamation
        End If
    End If

'**********
ErrHandler:
    'return null string
    GetSetConfiguration = ""
    Exit Function
    
End Function

Public Property Let ipAddress(ByVal vData As String)
    
    'set ip address
    mvarIPAddress = vData
    mvarTargetAddress = inet_addr(mvarIPAddress)
    
End Property

Public Property Get ipAddress() As String
    
    'get ip address
    ipAddress = mvarIPAddress
    
End Property

Public Property Let TargetNode(ByVal vData As Long)
    
    'set target node
    mvarTargetNode = vData
    
End Property

Public Property Get TargetNode() As Long
    
    'get target node
    TargetNode = mvarTargetNode
    
End Property

Public Property Let HostNode(ByVal vData As Long)
    
    'set host node
    mvarHostNode = vData
End Property

Public Property Get HostNode() As Long
    
    'get host node
    HostNode = mvarHostNode
    
End Property

Public Property Let BaudRate(ByVal vData As Long)
    
    'set baud rate
    mvarBaudRate = vData
    
End Property

Public Property Get BaudRate() As Long
    
    'get baud rate
    BaudRate = mvarBaudRate
    
End Property

Public Property Let Port(ByVal vData As Long)
    
    'set com port
    mvarPort = vData
    
End Property

Public Property Get Port() As Long
    
    'get com port
    Port = mvarPort
    
End Property

Public Property Let ConnectionType(ByVal vData As Long)
    
    'set connection type
    mvarConnectionType = vData
    
End Property

Public Property Get ConnectionType() As Long
    
    'get connection type
    ConnectionType = mvarConnectionType
    
End Property

Public Property Get ConnectionID() As Long
    
    'get ip address
    ConnectionID = mvarConnectionID
    
End Property
