
Public NotInheritable Class MainForm

    Private Sub btnReadReg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadReg.Click
        Dim results As Integer
        Dim value As Integer

        results = Ctccom32v2.CtGetRegister(CTconnection, Val(txtRegToRead.Text), value)
        If results = SUCCESS Then
            txtRegVal.Text = Convert.ToString(value)
        Else
            txtRegVal.Text = "ERROR"
        End If

    End Sub

    Private Sub btnReadVReg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadVReg.Click
        Dim results As Integer
        Dim Var As Ctccom32v2.CT_VARIANT

        ' Initialize Variant prior to read
        Var.vRegister = Val(txtVRegToRead.Text)
        Var.cmd = 0
        Var.flags = 0
        Var.FloatVar = 0
        Var.IntegerIntVar = 0
        Var.indexCol = Val(txtVCol.Text)
        Var.indexRow = Val(txtVRow.Text)
        Var.precision = 6
        If (chkInteger.Checked) Then
            Var.type = Ctccom32v2.CT_VARIANT_INTEGER
        ElseIf chkFloat.Checked Then
            Var.type = Ctccom32v2.CT_VARIANT_FLOAT
        ElseIf chkDouble.Checked Then
            Var.type = Ctccom32v2.CT_VARIANT_DOUBLE
        ElseIf chkString.Checked Then
            Var.type = Ctccom32v2.CT_VARIANT_STRING
        End If
        Var.taskHandle = 0
        ReDim Var.stringVar(223)  'this is 0 based so really 224
        '        Var.flags = Ctccom32v2.CT_VARIANT_DOUBLE_NOSWAP_FLAG   'VB6 has high/low word one way, VB.Net stores it the opposite, figures...

        results = Ctccom32v2.CtGetVRegister(CTconnection, Var)
        If results = SUCCESS Then
            If (Var.type = Ctccom32v2.CT_VARIANT_INTEGER) Then
                txtVRegVal.Text = Convert.ToString(Var.IntegerIntVar)
            ElseIf (Var.type = Ctccom32v2.CT_VARIANT_FLOAT) Then
                txtVRegVal.Text = Convert.ToString(Var.FloatVar)
            ElseIf (Var.type = Ctccom32v2.CT_VARIANT_DOUBLE) Then
                txtVRegVal.Text = Convert.ToString(Var.DoubleVar)
            ElseIf (Var.type = Ctccom32v2.CT_VARIANT_STRING) Then
                If (Var.slength > 0) Then
                    txtVRegVal.Text = System.Text.Encoding.ASCII.GetString(Var.stringVar)
                Else
                    txtVRegVal.Text = "No String?"
                End If
            Else
                txtVRegVal.Text = "ERROR"
            End If
        Else
            txtVRegVal.Text = "ERROR"
        End If

    End Sub

    Private Sub chkInteger_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkInteger.CheckedChanged
        If (chkInteger.Checked = True) Then
            chkFloat.Checked = False
            chkDouble.Checked = False
            chkString.Checked = False
        End If

    End Sub

    Private Sub chkFloat_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkFloat.CheckedChanged
        If (chkFloat.Checked = True) Then
            chkInteger.Checked = False
            chkDouble.Checked = False
            chkString.Checked = False
        End If
    End Sub

    Private Sub chkDouble_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDouble.CheckedChanged
        If (chkDouble.Checked = True) Then
            chkInteger.Checked = False
            chkFloat.Checked = False
            chkString.Checked = False
        End If
    End Sub

    Private Sub chkString_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkString.CheckedChanged
        If (chkString.Checked = True) Then
            chkInteger.Checked = False
            chkFloat.Checked = False
            chkDouble.Checked = False
        End If

    End Sub

    Private Sub btnWriteVReg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteVReg.Click
        Dim results As Integer
        Dim Var As Ctccom32v2.CT_VARIANT
        Dim tmpArray() As Byte
        Dim i As Integer

        ' Initialize Variant prior to read
        Var.vRegister = Val(txtVRegToRead.Text)
        Var.cmd = 0
        Var.flags = 0
        Var.FloatVar = 0
        Var.IntegerIntVar = 0
        Var.DoubleVar = 0
        Var.indexCol = Val(txtVCol.Text)
        Var.indexRow = Val(txtVRow.Text)
        Var.precision = 6
        '        ReDim Var.stringVar(223)  'this is 0 based so really 224
        writeStatus.Text = ""
        ReDim Var.stringVar(223)  'this is 0 based so really 224

        If (chkInteger.Checked) Then
            Var.type = Ctccom32v2.CT_VARIANT_INTEGER
            Var.IntegerIntVar = Convert.ToInt32(txtVRegVal.Text)
        ElseIf chkFloat.Checked Then
            Var.type = Ctccom32v2.CT_VARIANT_FLOAT
            Var.FloatVar = Convert.ToSingle(txtVRegVal.Text)
        ElseIf chkDouble.Checked Then
            Var.type = Ctccom32v2.CT_VARIANT_DOUBLE
            Var.DoubleVar = Convert.ToDouble(txtVRegVal.Text)
        ElseIf chkString.Checked Then
            Var.type = Ctccom32v2.CT_VARIANT_STRING
            Var.slength = txtVRegVal.Text.Length()
            Dim oEncoder As New System.Text.ASCIIEncoding()
            tmpArray = oEncoder.GetBytes(txtVRegVal.Text)
            ReDim Var.stringVar(223)  'this is 0 based so really 224
            ' Because of marshalling array must have size of 224 but we copy bytes into it and DLL uses slength
            For i = 0 To tmpArray.Length - 1
                Var.stringVar(i) = tmpArray(i)
            Next i

        End If
        Var.taskHandle = 0

        results = Ctccom32v2.CtSetVRegister(CTconnection, Var)
        If results = SUCCESS Then
            writeStatus.Text = "SUCCESS"
        Else
            writeStatus.Text = "ERROR"
        End If

    End Sub
End Class